**Please hit the preview button to read this.**

When submitting an issue, please take into account the following points.

* Decide where your issue belongs. If it is non-technical or
  conversational, it might be better-suited to [Discord](https://discord.gg/TFJqhsC).
* Make sure nobody else has already reported the issue.
  You can find a search bar above [the list of issues](https://github.com/GlowstoneMC/Glowstone/search?type=Issues).
  If you've found a similar or identical issue, consider leaving a comment
  there instead.
* Describe your issue clearly, giving instructions on how to
  reproduce it as far as you can.
* If you have an error log, be sure to include it, preferably
  at the bottom of your issue description.
* Be courteous and understand that Glowstone is maintained by
  passionate (but unpaid) individuals, in a team that is **much** smaller
  than similar teams for projects like Bukkit and Spigot.
* Remember that we have a [code of conduct](https://github.com/GlowstoneMC/Glowstone/blob/dev/docs/CODE_OF_CONDUCT.md). 
  If it isn't about Glowstone as an application (or its code), then it doesn't belong
  on GitHub. Keep things professional and impersonal.
* If English isn't your first language, we would prefer that you give it a try,
  but feel free to also include a version of the ticket in your native language.
  For example, if you're better at Russian, include both an English and a Russian
  version. It will help us to understand what you mean better.

If you like, you may use the following template.

---

Title: **Short description of the issue**

Glowstone build: `#123` (Never say *"latest"*, always check what build you're using). Alternatively, provide the Git commit hash.

Describe your problem in detail here. Explain what you were doing at the time,
what any other players were doing (if possible), what you were expecting to happen,
and what actually happened.

Explain the steps we can take to reproduce your problem. Ensure that they work - install
a fresh copy of Glowstone and try them out yourself to make sure they're accurate, at least
as far as possible.

If you have found issues that might relate to the one you're reporting, include links to them
or use `#123`, where `123` is the number of the issue you want to refer to.

---

Include any logs that you feel are relevant at the bottom. Surround them with three backticks 
( **```** ) on the lines directly above and below to ensure they're easy to read. If you don't do this,
a staff member may do it for you, so please don't be alarmed if that happens!
